%define         MS_REL 5x

Name:           mapserver%{MS_REL}
Version:        5.6.8
Release:        4%{?dist}
Summary:        Environment for building spatially-enabled internet applications

Group:          Development/Tools
License:        BSD
URL:            http://www.mapserver.org

Source:         http://download.osgeo.org/mapserver/mapserver-%{version}.tar.gz
Patch0:         %{name}-%{version}-java-%{MS_REL}.patch
Patch1:         %{name}-%{version}-perl-%{MS_REL}.patch
Patch2:         %{name}-%{version}-python-%{MS_REL}.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:       httpd

BuildRequires:  libXpm-devel
BuildRequires:  httpd-devel
BuildRequires:  php-devel
BuildRequires:  postgresql-devel >= 9.2
BuildRequires:  mysql-devel
BuildRequires:  geos-devel proj-devel gdal-devel
BuildRequires:  freetype-devel fribidi-devel gd-devel >= 2.0.16
BuildRequires:  python-devel curl-devel zlib-devel libxml2-devel libxslt-devel
BuildRequires:  libjpeg-devel libpng-devel libtiff-devel
BuildRequires:  perl(ExtUtils::MakeMaker)
BuildRequires:  java-1.6.0-openjdk-devel swig > 1.3.24 java-1.6.0-openjdk
BuildRequires:  fcgi-devel pam-devel readline-devel


%define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")
%define java_home /usr/lib/jvm/java-1.6.0

%description
Mapserver is an internet mapping program that converts GIS data to
map images in real time. With appropriate interface pages, 
Mapserver can provide an interactive internet map based on 
custom GIS data.

%package -n php-%{name}
Summary:        PHP/Mapscript map making extensions to PHP
Group:          Development/Languages
Requires:       httpd php-gd

%description -n php-%{name}
The PHP/Mapscript extension provides full map customization capabilities within
the PHP scripting language.

%package -n php-%{name}-proj
Summary:        PHP bindings for Proj.4
Group:          Development/Languages
Requires:       php proj 

%description -n php-%{name}-proj
The PHP bindings for Proj.4 allow the use of Proj.4 within the PHP scripting language.

%package perl
Summary:        Perl/Mapscript map making extensions to Perl
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}
Requires: perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description perl
The Perl/Mapscript extension provides full map customization capabilities
within the Perl programming language.

%package python
Summary:        Python/Mapscript map making extensions to Python
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}

%description python
The Python/Mapscript extension provides full map customization capabilities
within the Python programming language.

%package java
Summary:        Java/Mapscript map making extensions to Java
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}
Requires:       java-1.6.0-openjdk 

%description java
The Java/Mapscript extension provides full map customization capabilities
within the Java programming language.

%prep
%setup -n mapserver-%{version} -q
%patch0 -p1 -b .java
%patch1 -p1 -b .perl
%patch2 -p1 -b .python
# fix spurious perm bits
chmod -x tests/home.png
# chmod -x rfc/ms-rfc-8.txt
chmod -x mapscript/php3/php_mapscript.c
chmod -x mappluginlayer.c
chmod -x mapscript/php3/mapscript_i.c
chmod -x mapscript/php3/examples/test_writeshape.phtml
chmod -x mapscript/python/examples/*.py
chmod -x mapscript/python/tests/rundoctests.dist
chmod -x mapscript/perl/examples/*.pl
chmod -x mapscript/php3/README

%build

# fix a UTF-8 one
iconv -f ISO-8859-1 -t UTF-8 < \
mapscript/java/examples/QueryByAttributeUnicode.java > \
mapscript/java/examples/QueryByAttributeUnicode-tmp.java
mv -f mapscript/java/examples/QueryByAttributeUnicode-tmp.java \
mapscript/java/examples/QueryByAttributeUnicode.java

# fix gdal lookup
%{__sed} -i.libs -e 's|`\$GDAL_CONFIG --dep-libs`||' configure

%configure \
   --with-gd \
   --with-zlib \
   --with-tiff \
   --with-freetype=%{_bindir}/freetype-config \
   --with-gdal=%{_bindir}/gdal-config \
   --with-ogr=%{_bindir}/gdal-config \
   --with-geos=%{_bindir}/geos-config \
   --with-proj \
   --with-sos \
   --with-wfs \
   --with-wcs \
   --with-wmsclient \
   --with-wfsclient \
   --with-xpm \
   --with-agg \
   --with-postgis=%{_bindir}/pg_config \
   --with-mygis=%{_bindir}/mysql_config \
   --with-curl-config=%{_bindir}/curl-config \
   --with-xml2-config=%{_bindir}/xml2-config \
   --with-php=`php-config --include-dir` \
   --without-pdf \
   --without-eppl \
   --with-threads \
   --enable-debug \
   --with-fastcgi=/usr \
   --disable-runpath \
   --with-xml-mapfile \
   --with-experimental-png \
   --with-fribidi-config
#   --with-libiconv   \

# WARNING !!!
# using %{?_smp_mflags} may break build

#fix hardcoded issues
sed -i 's|-lpgport| |g' Makefile
sed -i 's|-lpgport| |g' mapscript/php3/Makefile
sed -i 's|-lpgport| |g' mapscript/csharp/Makefile
sed -i 's|-lpgport| |g' mapscript/java/Makefile

make

# build perl
cd mapscript/perl
mv mapscript.pm mapscript%{MS_REL}.pm
perl Makefile.PL
make

# build python
cd ../python
mv mapscript.py mapscript%{MS_REL}.py
python setup.py build

# build java
cd ../java
JAVA_HOME=%{java_home} make interface
JAVA_HOME=%{java_home} make

# build php_proj.so
cd ../php3
make php_proj.so

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_libexecdir}
mkdir -p %{buildroot}%{_sysconfdir}/php.d
mkdir -p %{buildroot}%{_libdir}/php/modules
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_datadir}/%{name}
install -p -m 755 mapserv %{buildroot}%{_libexecdir}/mapserver%{MS_REL}
install -p -m 755 shp2img %{buildroot}%{_bindir}/shp2img%{MS_REL}
install -p -m 755 shptree %{buildroot}%{_bindir}/shptree%{MS_REL}
install -p -m 755 sortshp %{buildroot}%{_bindir}/sortshp%{MS_REL}
install -p -m 755 tile4ms %{buildroot}%{_bindir}/tile4ms%{MS_REL}
install -p -m 644 xmlmapfile/mapfile.xsd %{buildroot}%{_datadir}/%{name}
install -p -m 644 xmlmapfile/mapfile.xsl %{buildroot}%{_datadir}/%{name}

install -p -m 755 mapscript/php3/php_mapscript.so %{buildroot}%{_libdir}/php/modules/php_mapscript%{MS_REL}.so
install -p -m 755 mapscript/php3/php_proj.so %{buildroot}%{_libdir}/php/modules/php_proj%{MS_REL}.so

# install perl module
pushd mapscript/perl
make DESTDIR=%{buildroot} pure_vendor_install
popd

# install python module
pushd mapscript/python
python setup.py install --root %{buildroot}
popd

# install java
mkdir -p %{buildroot}%{_javadir}
install -p -m 644 mapscript/java/mapscript%{MS_REL}.jar %{buildroot}%{_javadir}/
install -p -m 755 mapscript/java/libmapscript%{MS_REL}.so %{buildroot}%{_libdir}/

# install php config file
mkdir -p %{buildroot}%{_sysconfdir}/php.d/
cat > %{buildroot}%{_sysconfdir}/php.d/%{name}.ini <<EOF
; Enable %{name} extension module
extension=php_mapscript%{MS_REL}.so
EOF

# cleanup junks
for junk in {*.pod,*.bs,.packlist} ; do
find %{buildroot} -name "$junk" -exec rm -rf '{}' \;
done
# remove vera fonts, these are provided system wide
rm -rf %{buildroot}%{_docdir}/%{name}-%{version}/tests/vera

# fix some exec bits
chmod 755 %{buildroot}%{perl_vendorarch}/auto/mapscript%{MS_REL}/mapscript%{MS_REL}.so

%files
%defattr(-,root,root)
%doc README COMMITERS GD-COPYING HISTORY.TXT  
%doc INSTALL MIGRATION_GUIDE.TXT
%doc symbols tests
%doc fonts
%{_bindir}/shp2img%{MS_REL}
%{_bindir}/shptree%{MS_REL}
%{_bindir}/sortshp%{MS_REL}
%{_bindir}/tile4ms%{MS_REL}
%{_libexecdir}/%{name}
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*

%files -n php-%{name}
%defattr(-,root,root)
%doc mapscript/php3/README
%doc mapscript/php3/examples
%config(noreplace) %{_sysconfdir}/php.d/%{name}.ini
%{_libdir}/php/modules/php_mapscript%{MS_REL}.so

%files -n php-%{name}-proj
%defattr(-,root,root)
%{_libdir}/php/modules/php_proj%{MS_REL}.so

%files perl
%defattr(-,root,root)
%doc mapscript/perl/examples
%dir %{perl_vendorarch}/auto/mapscript%{MS_REL}
%{perl_vendorarch}/auto/mapscript%{MS_REL}/*
%{perl_vendorarch}/mapscript%{MS_REL}.pm

%files python
%defattr(-,root,root)
%doc mapscript/python/README
%doc mapscript/python/examples
%doc mapscript/python/tests
%{python_sitearch}/*

%files java
%defattr(-,root,root)
%doc mapscript/java/README
%doc mapscript/java/examples
%doc mapscript/java/tests
%{_javadir}/*.jar
%{_libdir}/libmapscript%{MS_REL}.so*

%changelog
* Fri Jul 18 2014 Pavel Lisy <pavel.lisy@gmail.com> - 5.6.8-4
- Rebuilt for geos 3.4.2

* Fri Oct 18 2013 Pavel LISY <pavel.lisy@gmail.com> - 5.6.8-3
- built with postgresql 9.2

* Fri Mar 08 2013 Pavel Lisy <pavel.lisy@gmail.com> - 5.6.8-2
- Rename to mapserver5x

* Thu Mar 07 2013 Pavel Lisy <pavel.lisy@gmail.com> - 5.6.8-1
- Version 5.6.8

* Tue Nov 08 2011 Mathieu Baudier <mbaudier@argeo.org> - 5.6.7-3_0
- Rebuild on Scientific Linux 6.1

* Wed Sep 28 2011 Nikos Hatzopoulos <nhatzop@gmail.com> - 5.6.7-3
- Add libmapscript (Java bindings)

* Sun Sep 25 2011 Mathieu Baudier <mbaudier@argeo.org> - 5.6.7-2
- Adapt to ELGIS 6 (Nikolaos Hatzopoulos <hatzopou@chapman.edu>)
- Rename to mapserver5

* Tue Jul 12 2011 Mathieu Baudier <mbaudier@argeo.org> - 5.6.7-1
- Version 5.6.7

* Tue May 03 2011 Mathieu Baudier <mbaudier@argeo.org> - 5.6.6-5
- Add FriBidi support
- Moved mapserv from %{_sbindir} to %{_libexecdir}, as suggested by Volker Fröhlich 

* Wed Apr 27 2011 Mathieu Baudier <mbaudier@argeo.org> - 5.6.6-4
- Add transparent PNG support

* Thu Apr 14 2011 Peter Hopfgartner <peter.hopfgartner@r3-gis.com> - 5.6.6-3
- Fix wrong php-gd require to php53-gd

* Tue Apr 12 2011 Peter Hopfgartner <peter.hopfgartner@r3-gis.com> - 5.6.6-2
- Fix wrong php require to php53

* Wed Feb 02 2011 Peter Hopfgartner <peter.hopfgartner@r3-gis.com> - 5.6.6-1
- New upstream version
- Obsoletes patch for http://trac.osgeo.org/mapserver/ticket/3497. 
- Uses php53 on EL5 

* Mon Dec 06 2010 Peter Hopfgartner <peter.hopfgartner@r3-gis.com> - 5.6.5-6
- Introduce php-mapserver-proj package

* Wed Nov 24 2010 Peter Hopfgartner <peter.hopfgartner@r3-gis.com> - 5.6.5-5
- Enable XML mapfiles

* Tue Nov 16 2010 Peter Hopfgartner <peter.hopfgartner@r3-gis.com> - 5.6.5-4
- Added patch for ticket http://trac.osgeo.org/mapserver/ticket/3497 

* Thu Sep 23 2010 Mathieu Baudier <mbaudier@argeo.org> - 5.6.5-3
- Remove agg dependencies

* Fri Sep 17 2010 Mathieu Baudier <mbaudier@argeo.org> - 5.6.5-2
- Build against GDAL 1.7.2

* Mon Jul 26 2010 Mathieu Baudier <mbaudier@argeo.org> - 5.6.5-1
- Update to 5.6.5

* Tue Jun 01 2010 Mathieu Baudier <mbaudier@argeo.org> - 5.6.3-1
- Update to 5.6.3
- Add missing build dependencies when building in mock

* Sun Jan 17 2010 Mathieu Baudier <mbaudier@argeo.org> - 5.6.0-2
- Add fcgi-devel build requirement

* Tue Oct 27 2009 Peter Hopfgartner <peter.hopfgartner@r3-gis.it> 5.6.0-beta4-1
- new 5.6.0-beta4 series upstream

* Tue Sep 15 2009 Peter Hopfgartner <peter.hopfgartner@r3-gis.it> 5.4.2-1
- new 5.4.2 series upstream

* Thu Jun 18 2009 Peter Hopfgartner <peter.hopfgartner@r3-gis.it> 5.2.1-1
- new 5.2.1 series upstream

* Wed Jul 23 2008 Balint Cristian <rezso@rdsor.ro> 5.2.0-1
- new 5.2 series upstream

* Sat Jul 05 2008 Balint Cristian <rezso@rdsor.ro> 5.0.3-3
- address bz#453925

* Thu Jun 26 2008 Devrim GUNDUZ <devrim@commandprompt.com> - 5.0.3-2
- Rebuilt against Geos 3.0.0

* Thu Jun 12 2008 Balint Cristian <rezso@rdsor.ro> 5.0.3-1
- update to 5.0.3 bugfix release
- fix some rpmlint warnings

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 5.0.2-2
- Autorebuild for GCC 4.3

* Sat Feb 9 2008 Devrim GUNDUZ <devrim@commandprompt.com> - 5.0.2-1
- Update to 5.0.2

* Sat Jan 5 2008 Devrim GUNDUZ <devrim@commandprompt.com> - 5.0.0-2
- Update BR for java-devel, per Patrice Dumas

* Fri Jan 4 2008 Devrim GUNDUZ <devrim@commandprompt.com> - 5.0.0-1
- Update to 5.0.0
- Removed patch0, since it is already in upstream.
- Updated BRs

* Thu Dec 06 2007 Release Engineering <rel-eng at fedoraproject dot org> - 4.10.3-3
- Rebuild for deps

* Thu Aug 30 2007 Oliver Falk <oliver@linux-kernel.at> 4.10.3-2
- Add fix to include libmapserver (in some places), instead of
  libmap, that doesn't exist (anymore)

* Thu Aug 30 2007 Oliver Falk <oliver@linux-kernel.at> 4.10.3-1
- Update to fix bz#256561, CVE-2007-4542

* Fri May 11 2007 Balint Cristian <cbalint@redhat.com> 4.10.2-4
- update require list properly.

* Thu May 10 2007 Balint Cristian <cbalint@redhat.com> 4.10.2-3
- use macros if possible in spec

* Thu May 10 2007 Balint Cristian <cbalint@redhat.com> 4.10.2-2
- further fixups for inclusion

* Thu May 10 2007 Balint Cristian <cbalint@redhat.com> 4.10.2-1
- new upsream tarball (bugfix)
- further fixups for inclusion

* Tue Apr 24 2007 Balint Cristian <cbalint@redhat.com> 4.10.1-3
- further fixups for inclusion
- enable java

* Fri Mar 16 2007 Balint Cristian <cbalint@redhat.com> 4.10.1-2
- add docs

* Fri Mar 16 2007 Balint Cristian <cbalint@redhat.com> 4.10.1-1
- first package
